"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }

var _chunkIOP7DGF3cjs = require('./chunk-IOP7DGF3.cjs');



var _chunkZNTN57VNcjs = require('./chunk-ZNTN57VN.cjs');







var _chunkHULDJDNDcjs = require('./chunk-HULDJDND.cjs');


var _chunkNBKYAXXNcjs = require('./chunk-NBKYAXXN.cjs');

// src/common/log/log-context.ts
function LoggerContext(_prefix = "") {
  let logHandlers = [_chunkIOP7DGF3cjs.LoggerConsoleHandler.call(void 0, )];
  let logCheckNamespace = (_name) => true;
  let logLock = false;
  let logFactory = LoggerBaseFactory;
  let logDebug = false;
  function LoggerBaseFactory(name = "", level) {
    const logLevel = _chunkZNTN57VNcjs.parseLogLevel.call(void 0, _nullishCoalesce(level, () => ( _chunkHULDJDNDcjs.LogLevelAll)));
    function defineForLogLevel(fnLevel, fn) {
      if (logLevel <= fnLevel)
        return fn;
      return () => {
      };
    }
    const emit = (msg) => {
      if (logCheckNamespace(name)) {
        for (const handler of logHandlers) {
          if (handler)
            handler(msg);
        }
      }
    };
    const log = defineForLogLevel(_chunkHULDJDNDcjs.LogLevelDebug, (...messages) => {
      emit({
        name,
        messages,
        level: _chunkHULDJDNDcjs.LogLevelDebug
      });
    });
    log.label = name;
    log.extend = function(prefix) {
      return logFactory(name ? `${name}:${prefix}` : prefix);
    };
    log.debug = defineForLogLevel(_chunkHULDJDNDcjs.LogLevelDebug, (...messages) => {
      emit({ name, messages, level: _chunkHULDJDNDcjs.LogLevelDebug });
    });
    log.info = defineForLogLevel(_chunkHULDJDNDcjs.LogLevelInfo, (...messages) => {
      emit({ name, messages, level: _chunkHULDJDNDcjs.LogLevelInfo });
    });
    log.warn = defineForLogLevel(_chunkHULDJDNDcjs.LogLevelWarn, (...messages) => {
      emit({ name, messages, level: _chunkHULDJDNDcjs.LogLevelWarn });
    });
    log.error = defineForLogLevel(_chunkHULDJDNDcjs.LogLevelError, (...messages) => {
      emit({ name, messages, level: _chunkHULDJDNDcjs.LogLevelError });
    });
    log.fatal = defineForLogLevel(_chunkHULDJDNDcjs.LogLevelFatal, (...messages) => {
      emit({ name, messages, level: _chunkHULDJDNDcjs.LogLevelFatal });
      throw new Error(`${messages.map(String).join(" ")}`);
    });
    log.assert = defineForLogLevel(_chunkHULDJDNDcjs.LogLevelFatal, (condition, ...args) => {
      if (condition == null || typeof condition === "number" && Number.isNaN(condition) || !condition)
        log.fatal(...args);
    });
    return log;
  }
  function Logger(name = "", level) {
    const log = logFactory(name, level);
    if (logDebug)
      log.debug(`+++ init of logger "${name}" on level "${log.level}".`);
    return log;
  }
  Logger.registerHandler = function(handler) {
    logHandlers.push(handler);
  };
  Logger.setFilter = function(namespaces) {
    logCheckNamespace = _chunkZNTN57VNcjs.useNamespaceFilter.call(void 0, namespaces);
  };
  Logger.setLock = (lock = true) => logLock = lock;
  Logger.setDebug = (debug = true) => logDebug = debug;
  Logger.setHandlers = (handlers) => {
    if (logFactory !== LoggerBaseFactory)
      logFactory = LoggerBaseFactory;
    if (handlers != null && !logLock)
      logHandlers = [...handlers].filter(_chunkNBKYAXXNcjs.isNotNull);
  };
  Logger.level = _chunkHULDJDNDcjs.LogLevelAll;
  Logger.setLogLevel = function(level = _chunkHULDJDNDcjs.LogLevelAll) {
    if (logLock)
      return;
    Logger.level = level;
  };
  Logger.setFactory = function(factory) {
    if (logLock)
      return;
    logFactory = factory;
  };
  return Logger;
}



exports.LoggerContext = LoggerContext;
//# sourceMappingURL=chunk-NUAYMDDK.cjs.map