import "../chunk-HMRSQHLY.js";
import "../chunk-UMUHNSGZ.js";
import "../chunk-AFR4TBTH.js";
import "../chunk-TPBBZQSO.js";
import "../chunk-MO24G7VK.js";
import "../chunk-2PE4OYYB.js";
import "../chunk-RNL46FQ3.js";
import "../chunk-MWUFUBY5.js";
import "../chunk-GKKLBSFA.js";
import "../chunk-VIMKC4ZH.js";
import "../chunk-THQONF76.js";
import "../chunk-FLFB2K34.js";
import "../chunk-264HKVNG.js";
import "../chunk-HST4VI64.js";
import "../chunk-Y4Y2UW4C.js";
import "../chunk-GZUTQZ3U.js";
import "../chunk-QFCI276X.js";
import "../chunk-CZRBSDM4.js";
import "../chunk-EW6FHLFK.js";
import "../chunk-KF7VWGCK.js";
import "../chunk-MPAXUMZ5.js";
import "../chunk-2GSKQ3JD.js";
import "../chunk-EMAWKJ2Y.js";
import "../chunk-UNDIGSHA.js";
import "../chunk-7OAUULYN.js";
import "../chunk-2T2C276H.js";
import "../chunk-ZESYG7WE.js";
import "../chunk-T77VRAAN.js";
import "../chunk-CLYTKZXT.js";
import "../chunk-X356T6ZJ.js";
import "../chunk-6DVQ64MF.js";
import "../chunk-DQMBSAP6.js";
import "../chunk-UMFGZFFE.js";
import "../chunk-7GOLOL5D.js";
import "../chunk-RXQQW2PV.js";
import {
  DefaultLogger
} from "../chunk-RVBBTDXC.js";
import "../chunk-VSJ34R4O.js";
import "../chunk-QXMTSRRE.js";
import "../chunk-CFICINSP.js";
import {
  decrypt,
  deriveKeyPbkdf2,
  digest,
  encrypt,
  randomUint8Array
} from "../chunk-CRVSXYJ4.js";
import "../chunk-I45WP5PM.js";
import "../chunk-MZ2ODZKK.js";
import "../chunk-ER2NNANC.js";
import "../chunk-EJVKADTL.js";
import "../chunk-UHTVWILC.js";
import "../chunk-UYBQWMJC.js";
import "../chunk-XSB2WAW2.js";
import "../chunk-AS5LR4AI.js";
import "../chunk-5Y3HYG6B.js";
import "../chunk-AFUVZLZZ.js";
import "../chunk-WWSHZF6M.js";
import "../chunk-NYCGHEIN.js";
import "../chunk-S7CUSMDX.js";
import "../chunk-FL5CT6MC.js";
import "../chunk-2HWPZ6ZE.js";
import "../chunk-HLRQ5H3N.js";
import "../chunk-5J5P77E5.js";
import "../chunk-G73H5WQB.js";
import "../chunk-DGP32WEQ.js";
import "../chunk-73CVRDI7.js";
import "../chunk-KG4L5KVT.js";
import "../chunk-SRGFRO74.js";
import "../chunk-ACZDEHYB.js";
import "../chunk-FSDCRQB3.js";
import "../chunk-YEEGQOIW.js";
import "../chunk-TWPB455K.js";
import "../chunk-IZT6OHMS.js";
import "../chunk-JU2MYLJO.js";
import "../chunk-HR2TKQFG.js";
import "../chunk-TYWNSO7K.js";
import "../chunk-ZMFW3O35.js";
import "../chunk-5MAHDO36.js";
import "../chunk-7NSVDPHN.js";
import {
  equalBinary,
  toHex
} from "../chunk-VTQBCMZR.js";
import "../chunk-6GHO7LQW.js";

// src/common/crypto.spec.ts
var log = DefaultLogger("crypto.spec");
describe("crypto", () => {
  it("should not have collisions", () => {
    expect(equalBinary(new Uint8Array(2), new Uint8Array([0, 0]))).toBe(true);
    const list = Array.apply(null, Array(100)).map(
      () => randomUint8Array(8)
    );
    let id;
    while (id = list.pop()) {
      expect(equalBinary(id, new Uint8Array([0, 0, 0, 0, 0, 0, 0, 0]))).toBe(
        false
      );
      expect(id?.length).toBe(8);
      expect(list).not.toContain(id);
    }
  });
  it("should digest", async () => {
    expect(toHex(await digest("abc"))).toBe(
      "ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad"
    );
    expect(await digest(new Uint8Array([1, 2, 3]))).toMatchInlineSnapshot(`
Uint8Array [
  3,
  144,
  88,
  198,
  242,
  192,
  203,
  73,
  44,
  83,
  59,
  10,
  77,
  20,
  239,
  119,
  204,
  15,
  120,
  171,
  204,
  206,
  213,
  40,
  125,
  132,
  161,
  162,
  1,
  28,
  251,
  129,
]
`);
  });
  it("should raw crypt", async () => {
    const key = await deriveKeyPbkdf2(new Uint8Array([1, 2, 3]), {
      salt: new Uint8Array([1, 2, 3])
    });
    const sample = new Uint8Array([9, 8, 7, 6, 5, 4, 3, 2, 1, 0]);
    const cipher = await encrypt(sample, key);
    const bin = await decrypt(cipher, key);
    expect(equalBinary(sample, bin)).toBe(true);
    const binFix = await decrypt(
      new Uint8Array([
        1,
        1,
        27,
        108,
        252,
        31,
        238,
        192,
        61,
        168,
        45,
        29,
        128,
        212,
        215,
        222,
        205,
        105,
        178,
        193,
        150,
        36,
        24,
        216,
        180,
        75,
        168,
        133,
        37,
        25,
        124,
        137,
        221,
        103,
        214,
        97,
        218,
        232,
        248,
        93
      ]),
      key
    );
    expect(binFix).toEqual(sample);
  });
});
//# sourceMappingURL=crypto.spec.js.map