"use strict";




var _chunkMQW5ML2Scjs = require('../../chunk-MQW5ML2S.cjs');



var _chunkSBGQDG53cjs = require('../../chunk-SBGQDG53.cjs');
require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-GJ2NCPKV.cjs');


var _chunkM3E66RODcjs = require('../../chunk-M3E66ROD.cjs');
require('../../chunk-7FPSHSSO.cjs');

// src/common/data/sortable.spec.ts
describe("sortable", () => {
  const list = [-0.2, -1e-3, 0, 1e-3, 2];
  const items = list.map((sort_weight, index) => ({ index, sort_weight }));
  it("should add correctly", () => {
    expect(_chunkMQW5ML2Scjs.startSortWeight.call(void 0, items)).toBeLessThan(list[0]);
    expect(_chunkMQW5ML2Scjs.endSortWeight.call(void 0, items)).toBeGreaterThan(_chunkM3E66RODcjs.last.call(void 0, list) || 0);
  });
  it("should sort correctly", () => {
    const shuffledItems = _chunkSBGQDG53cjs.arrayShuffleForce.call(void 0, items);
    expect(shuffledItems.map((el) => el.sort_weight)).not.toEqual(list);
    expect(_chunkMQW5ML2Scjs.sortedItems.call(void 0, shuffledItems).map((el) => el.sort_weight)).toEqual(list);
  });
  it("should move correctly", () => {
    let items2 = [];
    for (let i = 0; i < 10; i++) {
      items2.push({
        name: String(i),
        sort_weight: i
      });
    }
    expect(
      _chunkMQW5ML2Scjs.sortedItems.call(void 0, items2).map((o) => o.name).join("")
    ).toEqual("0123456789");
    const moveItem = items2[8];
    moveItem.sort_weight = _chunkMQW5ML2Scjs.moveSortWeight.call(void 0, 1, 8, items2);
    expect(
      _chunkMQW5ML2Scjs.sortedItems.call(void 0, items2).map((o) => o.name).join("")
    ).toEqual("0812345679");
    items2 = _chunkMQW5ML2Scjs.sortedItems.call(void 0, items2);
    const moveItem2 = items2[1];
    _chunkSBGQDG53cjs.arrayShuffleInPlace.call(void 0, items2);
    moveItem2.sort_weight = _chunkMQW5ML2Scjs.moveSortWeight.call(void 0, 8, 1, items2);
    expect(
      _chunkMQW5ML2Scjs.sortedItems.call(void 0, items2).map((o) => o.name).join("")
    ).toEqual("0123456789");
  });
});
//# sourceMappingURL=sortable.spec.cjs.map