"use strict"; function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }require('../chunk-NU2LARFE.cjs');
require('../chunk-2M3GJPSG.cjs');
require('../chunk-QLGR2XSS.cjs');
require('../chunk-TL4N37LA.cjs');
require('../chunk-BYF3QB24.cjs');
require('../chunk-B5AT6K6M.cjs');
require('../chunk-BXH2HPYJ.cjs');
require('../chunk-ERVYLT2H.cjs');
require('../chunk-XSRNCOKE.cjs');
require('../chunk-MSQZVEZQ.cjs');
require('../chunk-6SRH3V26.cjs');
require('../chunk-XAL26J27.cjs');
require('../chunk-SFWHUH7N.cjs');
require('../chunk-ZKRBNIEC.cjs');



var _chunkTIMCWHOBcjs = require('../chunk-TIMCWHOB.cjs');
require('../chunk-XG57S66T.cjs');
require('../chunk-OWJR6AQM.cjs');


var _chunkKEJ4ER36cjs = require('../chunk-KEJ4ER36.cjs');
require('../chunk-NUAYMDDK.cjs');
require('../chunk-IOP7DGF3.cjs');
require('../chunk-ZYPCVNSG.cjs');
require('../chunk-OYAX4GVN.cjs');
require('../chunk-N46W55MH.cjs');
require('../chunk-ZNTN57VN.cjs');
require('../chunk-HULDJDND.cjs');
require('../chunk-44QLSR3L.cjs');
require('../chunk-CXBBK7CI.cjs');
require('../chunk-4OVLRIUA.cjs');
require('../chunk-DRTH56G4.cjs');
require('../chunk-KTC5RW57.cjs');
require('../chunk-A4VFMLAN.cjs');
require('../chunk-7XAMJGPO.cjs');
require('../chunk-MQW5ML2S.cjs');
require('../chunk-XWE2OTGL.cjs');
require('../chunk-7BL7WPL3.cjs');
require('../chunk-MPD2DJAD.cjs');
require('../chunk-ZGKV237Z.cjs');
require('../chunk-YELWQAMG.cjs');
require('../chunk-YZSOTFZT.cjs');
require('../chunk-NBKYAXXN.cjs');
require('../chunk-FEYF6QXS.cjs');
require('../chunk-N7OUNPMM.cjs');
require('../chunk-BXHLYONU.cjs');
require('../chunk-DSA7V4QZ.cjs');
require('../chunk-UXNJ5WZM.cjs');


var _chunkQYCE2TUJcjs = require('../chunk-QYCE2TUJ.cjs');
require('../chunk-ANZPWIO4.cjs');
require('../chunk-SBGQDG53.cjs');
require('../chunk-PJXRDQ2A.cjs');
require('../chunk-GJ2NCPKV.cjs');
require('../chunk-NUA44STS.cjs');
require('../chunk-FYLSPYV2.cjs');
require('../chunk-YKRFYR2Q.cjs');
require('../chunk-M3E66ROD.cjs');
require('../chunk-BMRI2X66.cjs');
require('../chunk-ADJUZEHB.cjs');
require('../chunk-7FPSHSSO.cjs');

// src/common/dispose-defer.spec.ts
var log = _chunkKEJ4ER36cjs.DefaultLogger.call(void 0, "dispose-test");
describe("dispose", () => {
  it("should dispose correctly", async () => {
    const disposeCalls = [];
    const dispose = _chunkTIMCWHOBcjs.useDispose.call(void 0, "a");
    const y = dispose.track({
      dispose() {
        disposeCalls.push(1);
      }
    });
    dispose.track(() => {
      disposeCalls.push(2);
    });
    const x = {
      async dispose() {
        disposeCalls.push(3);
      }
    };
    dispose.track(x);
    dispose.track();
    dispose.track(async () => {
      disposeCalls.push(4);
    });
    expect(disposeCalls).toEqual([]);
    expect(dispose.getSize()).toEqual(4);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3]);
    expect(dispose.getSize()).toEqual(3);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3]);
    expect(dispose.getSize()).toEqual(3);
    _optionalChain([y, 'optionalCall', _ => _()]);
    _optionalChain([y, 'optionalCall', _2 => _2()]);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3, 1]);
    expect(dispose.getSize()).toEqual(2);
    await dispose.dispose();
    expect(disposeCalls).toEqual([3, 1, 4, 2]);
    expect(dispose.getSize()).toEqual(0);
    await dispose();
    expect(disposeCalls).toEqual([3, 1, 4, 2]);
    expect(dispose.getSize()).toEqual(0);
  });
  it("should be a fancy dispose itself", () => {
    let x = 1;
    class Some {
      constructor() {
        this.dispose = _chunkTIMCWHOBcjs.useDispose.call(void 0, log);
        this.dispose.track(() => {
          x = 2;
        });
      }
    }
    const obj = new Some();
    expect(x).toBe(1);
    void obj.dispose();
    expect(x).toBe(2);
  });
  it("should defer lifo", async () => {
    const stack = [];
    const defer = _chunkTIMCWHOBcjs.useDefer.call(void 0, { mode: "lifo" });
    defer.add(() => stack.push("a"));
    defer.add(() => stack.push("b"));
    defer.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    void defer(true);
    expect(stack).toEqual(["c", "b", "a"]);
  });
  it("should defer fifo", async () => {
    const stack = [];
    const defer = _chunkTIMCWHOBcjs.useDefer.call(void 0, { mode: "fifo" });
    defer.add(() => stack.push("a"));
    defer.add(async () => stack.push("b"));
    defer.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    await defer();
    expect(stack).toEqual(["a", "b", "c"]);
  });
  it("should dispose sync", async () => {
    const stack = [];
    const dispose = _chunkTIMCWHOBcjs.useDispose.call(void 0, );
    dispose.add(() => stack.push("a"));
    dispose.add(() => stack.push("b"));
    dispose.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    await dispose(true);
    expect(stack).toEqual(["c", "b", "a"]);
  });
  it("should dispose sync 2", async () => {
    const stack = [];
    const dispose = _chunkTIMCWHOBcjs.useDispose.call(void 0, );
    dispose.add(() => stack.push("a"));
    dispose.add(() => stack.push("b"));
    dispose.add(async () => {
      await _chunkQYCE2TUJcjs.sleep.call(void 0, 1);
      stack.push("c");
    });
    expect(stack).toEqual([]);
    expect(dispose.sync).toThrowError();
  });
});
//# sourceMappingURL=dispose-defer.spec.cjs.map