"use strict";





var _chunkZNTN57VNcjs = require('../../chunk-ZNTN57VN.cjs');







var _chunkHULDJDNDcjs = require('../../chunk-HULDJDND.cjs');
require('../../chunk-CXBBK7CI.cjs');
require('../../chunk-4OVLRIUA.cjs');
require('../../chunk-DRTH56G4.cjs');
require('../../chunk-KTC5RW57.cjs');
require('../../chunk-A4VFMLAN.cjs');
require('../../chunk-7XAMJGPO.cjs');
require('../../chunk-MQW5ML2S.cjs');
require('../../chunk-XWE2OTGL.cjs');
require('../../chunk-7BL7WPL3.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-YZSOTFZT.cjs');
require('../../chunk-NBKYAXXN.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-BXHLYONU.cjs');
require('../../chunk-DSA7V4QZ.cjs');
require('../../chunk-UXNJ5WZM.cjs');
require('../../chunk-QYCE2TUJ.cjs');
require('../../chunk-ANZPWIO4.cjs');
require('../../chunk-SBGQDG53.cjs');
require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-GJ2NCPKV.cjs');
require('../../chunk-NUA44STS.cjs');
require('../../chunk-FYLSPYV2.cjs');
require('../../chunk-YKRFYR2Q.cjs');
require('../../chunk-M3E66ROD.cjs');
require('../../chunk-BMRI2X66.cjs');
require('../../chunk-ADJUZEHB.cjs');
require('../../chunk-7FPSHSSO.cjs');

// src/common/log/log-filter.spec.ts
describe("log-filter", () => {
  it("should match", () => {
    {
      const matches = _chunkZNTN57VNcjs.useNamespaceFilter.call(void 0, "a");
      expect(matches.filter).toBe("a");
      expect(matches.accept).toEqual([/^a/]);
      expect(matches.reject).toEqual([]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(false);
    }
    {
      const matches = _chunkZNTN57VNcjs.useNamespaceFilter.call(void 0, "a*");
      expect(matches.filter).toBe("a*");
      expect(matches.accept).toEqual([/^a.*?/]);
      expect(matches.reject).toEqual([]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(false);
    }
    {
      const matches = _chunkZNTN57VNcjs.useNamespaceFilter.call(void 0, "a*,b*,-c*");
      expect(matches.filter).toBe("a*,b*,-c*");
      expect(matches.accept).toEqual([/^a.*?/, /^b.*?/]);
      expect(matches.reject).toEqual([/^c.*?/]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(true);
      expect(matches("c:d")).toBe(false);
    }
    {
      const matches = _chunkZNTN57VNcjs.useNamespaceFilter.call(void 0, "*,-c*");
      expect(matches.filter).toBe("*,-c*");
      expect(matches.accept).toEqual([/^.*?/]);
      expect(matches.reject).toEqual([/^c.*?/]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(true);
      expect(matches("c:d")).toBe(false);
    }
    {
      const matches = _chunkZNTN57VNcjs.useNamespaceFilter.call(void 0, "*,-c");
      expect(matches.filter).toBe("*,-c");
      expect(matches.accept).toEqual([/^.*?/]);
      expect(matches.reject).toEqual([/^c/]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(true);
      expect(matches("c:d")).toBe(false);
    }
    {
      const matches = _chunkZNTN57VNcjs.useNamespaceFilter.call(void 0, "*");
      expect(matches.filter).toBe("*");
      expect(matches.accept).toEqual([]);
      expect(matches.reject).toEqual([]);
      expect(matches("a")).toBe(true);
      expect(matches("b:c")).toBe(true);
    }
  });
  it("should interprete filter right", () => {
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, "")).toEqual("");
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, 0)).toEqual("");
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, false)).toEqual("");
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, "false")).toEqual("");
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, null)).toEqual("");
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, "*")).toEqual("*");
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, 1)).toEqual("*");
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, true)).toEqual("*");
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, "true")).toEqual("*");
    expect(_chunkZNTN57VNcjs.getNamespaceFilterString.call(void 0, "a:b")).toEqual("a:b");
  });
  it("should filter by level", () => {
    {
      const levelFilter = _chunkZNTN57VNcjs.useLevelFilter.call(void 0, "err");
      expect(levelFilter(_chunkHULDJDNDcjs.LogLevelDebug)).toBe(false);
      expect(levelFilter(_chunkHULDJDNDcjs.LogLevelWarn)).toBe(false);
      expect(levelFilter(_chunkHULDJDNDcjs.LogLevelError)).toBe(true);
    }
    {
      const levelFilter = _chunkZNTN57VNcjs.useLevelFilter.call(void 0, "adfdfds");
      expect(levelFilter(_chunkHULDJDNDcjs.LogLevelDebug)).toBe(true);
      expect(levelFilter(_chunkHULDJDNDcjs.LogLevelWarn)).toBe(true);
      expect(levelFilter(_chunkHULDJDNDcjs.LogLevelError)).toBe(true);
    }
    {
      const levelFilter = _chunkZNTN57VNcjs.useLevelFilter.call(void 0, _chunkHULDJDNDcjs.LogLevelWarn);
      expect(levelFilter(_chunkHULDJDNDcjs.LogLevelDebug)).toBe(false);
      expect(levelFilter(_chunkHULDJDNDcjs.LogLevelWarn)).toBe(true);
      expect(levelFilter(_chunkHULDJDNDcjs.LogLevelError)).toBe(true);
    }
  });
  it("should identify log level", () => {
    expect(_chunkZNTN57VNcjs.parseLogLevel.call(void 0, false)).toEqual(_chunkHULDJDNDcjs.LogLevelOff);
    expect(_chunkZNTN57VNcjs.parseLogLevel.call(void 0, "info")).toEqual(_chunkHULDJDNDcjs.LogLevelInfo);
    expect(_chunkZNTN57VNcjs.parseLogLevel.call(void 0, _chunkHULDJDNDcjs.LogLevelError)).toEqual(_chunkHULDJDNDcjs.LogLevelError);
    expect(_chunkZNTN57VNcjs.parseLogLevel.call(void 0, true)).toEqual(_chunkHULDJDNDcjs.LogLevelAll);
    expect(_chunkZNTN57VNcjs.parseLogLevel.call(void 0, 2)).toEqual(_chunkHULDJDNDcjs.LogLevelWarn);
  });
  it("should join strings", () => {
    expect(_chunkZNTN57VNcjs.joinLogStrings.call(void 0, "test")).toEqual(["test"]);
    expect(_chunkZNTN57VNcjs.joinLogStrings.call(void 0, "test", "more", 1, 2, 3)).toEqual(["test more", 1, 2, 3]);
    expect(_chunkZNTN57VNcjs.joinLogStrings.call(void 0, "test", { a: 1 })).toEqual(["test", { a: 1 }]);
    expect(_chunkZNTN57VNcjs.joinLogStrings.call(void 0, "test", "a", "b", true, void 0, null, { a: 1 })).toEqual(["test a", "b", true, void 0, null, { a: 1 }]);
  });
});
//# sourceMappingURL=log-filter.spec.cjs.map