"use strict";

var _chunkOWJR6AQMcjs = require('../../chunk-OWJR6AQM.cjs');


var _chunkNUAYMDDKcjs = require('../../chunk-NUAYMDDK.cjs');
require('../../chunk-IOP7DGF3.cjs');
require('../../chunk-ZNTN57VN.cjs');


var _chunkHULDJDNDcjs = require('../../chunk-HULDJDND.cjs');
require('../../chunk-44QLSR3L.cjs');
require('../../chunk-CXBBK7CI.cjs');
require('../../chunk-4OVLRIUA.cjs');
require('../../chunk-DRTH56G4.cjs');
require('../../chunk-KTC5RW57.cjs');
require('../../chunk-A4VFMLAN.cjs');
require('../../chunk-7XAMJGPO.cjs');
require('../../chunk-MQW5ML2S.cjs');
require('../../chunk-XWE2OTGL.cjs');
require('../../chunk-7BL7WPL3.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-YZSOTFZT.cjs');
require('../../chunk-NBKYAXXN.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-BXHLYONU.cjs');
require('../../chunk-DSA7V4QZ.cjs');
require('../../chunk-UXNJ5WZM.cjs');
require('../../chunk-QYCE2TUJ.cjs');
require('../../chunk-ANZPWIO4.cjs');
require('../../chunk-SBGQDG53.cjs');
require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-GJ2NCPKV.cjs');
require('../../chunk-NUA44STS.cjs');
require('../../chunk-FYLSPYV2.cjs');
require('../../chunk-YKRFYR2Q.cjs');
require('../../chunk-M3E66ROD.cjs');
require('../../chunk-BMRI2X66.cjs');
require('../../chunk-ADJUZEHB.cjs');
require('../../chunk-7FPSHSSO.cjs');

// src/common/log/log-memory.spec.ts
describe("log-memory", () => {
  it("should log into memory", async () => {
    const messages = [];
    const logger = _chunkNUAYMDDKcjs.LoggerContext.call(void 0, );
    logger.setHandlers([
      _chunkOWJR6AQMcjs.LoggerMemoryHandler.call(void 0, {
        level: _chunkHULDJDNDcjs.LogLevelAll,
        filter: "*",
        messages
      })
    ]);
    const log = logger("test");
    log("Simple");
    log.debug("Hello");
    log.info("World");
    log.warn("is on");
    log.error("Fire");
    try {
      log.assert(false, "Fatal");
    } catch (err) {
    }
    expect(messages.map((msg) => {
      delete msg.timestamp;
      return msg;
    })).toMatchInlineSnapshot(`
      Array [
        Object {
          "level": 0,
          "messages": Array [
            "Simple",
          ],
          "name": "test",
        },
        Object {
          "level": 0,
          "messages": Array [
            "Hello",
          ],
          "name": "test",
        },
        Object {
          "level": 1,
          "messages": Array [
            "World",
          ],
          "name": "test",
        },
        Object {
          "level": 2,
          "messages": Array [
            "is on",
          ],
          "name": "test",
        },
        Object {
          "level": 3,
          "messages": Array [
            "Fire",
          ],
          "name": "test",
        },
        Object {
          "level": 4,
          "messages": Array [
            "Fatal",
          ],
          "name": "test",
        },
      ]
    `);
  });
});
//# sourceMappingURL=log-memory.spec.cjs.map